// Generated by CoffeeScript 2.5.0
(function() {
  var DEFAULT_TIMEOUT, _, cond, get, getAll, getAttribute, set, timeout, wait;

  _ = require('lodash');

  ({timeout} = require('../utils'));

  cond = protractor.ExpectedConditions;

  DEFAULT_TIMEOUT = function() {
    return testx.params.actionTimeout || 5000;
  };

  get = async function(key) {
    var el;
    el = (await testx.element(key).wait(DEFAULT_TIMEOUT()));
    return (await el.get());
  };

  getAttribute = async function(key, attribute) {
    var el;
    el = (await testx.element(key).wait(DEFAULT_TIMEOUT()));
    return (await el.getAttribute(attribute));
  };

  getAll = async function(key) {
    return (await testx.elements(key));
  };

  set = async function(key, value) {
    var e, el, ref;
    await wait({
      objects: [key]
    }, cond.elementToBeClickable);
    el = (await testx.element(key));
    try {
      return (await el.set(value));
    } catch (error) {
      e = error;
      if (e.name === "WebDriverError" && e.message.includes("element click intercepted")) {
        await wait({
          objects: [key],
          timeout: ((ref = testx.params.disruptiveElement) != null ? ref.timeout : void 0) || "30s"
        }, cond.elementToBeClickable);
        return set(key, value);
      }
    }
  };

  wait = async function(args, condition = cond.visibilityOf) {
    var e, el, i, len, loadEl, obj, ref, ref1, results, tmt;
    ref = args.objects;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      obj = ref[i];
      tmt = timeout(args.timeout, DEFAULT_TIMEOUT());
      el = (await testx.element(obj));
      try {
        results.push((await el.wait(tmt, condition)));
      } catch (error) {
        e = error;
        if (e.name === "TimeoutError" && ((ref1 = testx.params.disruptiveElement) != null ? ref1.selector : void 0)) {
          loadEl = (await testx.element(testx.params.disruptiveElement.selector));
          try {
            await loadEl.wait(500, cond.visibilityOf);
            await loadEl.wait(testx.params.disruptiveElement.timeout || "30s", cond.invisibilityOf);
            results.push((await el.wait(tmt, condition)));
          } catch (error) {
            throw e;
          }
        } else {
          throw e;
        }
      }
    }
    return results;
  };

  module.exports = {
    get: get,
    getAll: getAll,
    getAttribute: getAttribute,
    set: set,
    wait: wait,
    convertSimpleArgs: function(args, defaultArg, toArray = false) {
      var arg;
      if (typeof args !== 'object' || Array.isArray(args)) {
        arg = args;
        args = {};
        args[defaultArg] = toArray ? [arg] : arg;
      }
      return args;
    }
  };

}).call(this);
