// Generated by CoffeeScript 2.5.0
(function() {
  var _, assert, check, get, getAll, getAttribute;

  _ = require('lodash');

  ({get, getAll, getAttribute} = require('./api'));

  assert = require('../assert');

  check = function(condition, positive = true) {
    return async function(args, ctx) {
      var attr, cond, expected, key, results, val;
      results = [];
      for (key in args) {
        val = args[key];
        if (typeof val === 'object') {
          results.push((await (async function() {
            var results1;
            results1 = [];
            for (attr in val) {
              expected = val[attr];
              cond = expect((await getAttribute(key, attr)));
              if (!positive) {
                cond = cond.not;
              }
              results1.push((await cond[condition](expected)));
            }
            return results1;
          })()));
        } else {
          cond = expect((await get(key)));
          if (!positive) {
            cond = cond.not;
          }
          results.push((await cond[condition](val)));
        }
      }
      return results;
    };
  };

  module.exports = {
    'check equals': check('toEqual'),
    'check not equals': check('toEqual', false),
    'check matches': check('toMatch'),
    'check not matches': check('toMatch', false),
    'check exists': async function(args, ctx) {
      var key, results, val, values;
      results = [];
      for (key in args) {
        val = args[key];
        values = (await getAll(key));
        if (val || val === '') {
          results.push(expect(values != null ? values.length : void 0).toBeTruthy());
        } else {
          results.push(expect(values != null ? values.length : void 0).toBeFalsy());
        }
      }
      return results;
    },
    'check enabled': async function(args, ctx) {
      var el, key, results, val;
      results = [];
      for (key in args) {
        val = args[key];
        el = (await testx.element(key));
        results.push(expect((await el.isEnabled())).toBe(val));
      }
      return results;
    },
    'check readonly': async function(args, ctx) {
      var actual, el, expected, key, results, val;
      results = [];
      for (key in args) {
        val = args[key];
        expected = val ? val : null;
        el = (await testx.element(key));
        actual = (await el.getAttribute('readonly'));
        results.push(expect(actual).toBe(expected));
      }
      return results;
    }
  };

}).call(this);
