// Generated by CoffeeScript 2.5.0
(function() {
  var _, convertSimpleArgs, get, set,
    indexOf = [].indexOf;

  _ = require('lodash');

  ({get, set, convertSimpleArgs} = require('./api'));

  module.exports = {
    'get': async function(keys) {
      var i, key, len, results;
      results = [];
      for (i = 0, len = keys.length; i < len; i++) {
        key = keys[i];
        results.push((await get(key)));
      }
      return results;
    },
    'set': async function(args) {
      var key, results, val;
      results = [];
      for (key in args) {
        val = args[key];
        results.push((await set(key, val)));
      }
      return results;
    },
    'switch to': function(args) {
      if (args.title) {
        return Promise.all(browser.getAllWindowHandles().then(function(handles) {
          return _.map(handles, function(wh) {
            return browser.switchTo().window(wh).then(function() {
              return browser.getTitle().then(function(t) {
                return {
                  title: t,
                  handle: wh
                };
              });
            });
          });
        })).then(function(titles) {
          var i, len, ref, results, t, ttls;
          ttls = (function() {
            var i, len, results;
            results = [];
            for (i = 0, len = titles.length; i < len; i++) {
              t = titles[i];
              results.push(t.title);
            }
            return results;
          })();
          if (ref = args.title, indexOf.call(ttls, ref) < 0) {
            throw new Error(`Could not find a window with title '${args.title}'! Known windows are [${ttls}].`);
          } else {
            results = [];
            for (i = 0, len = titles.length; i < len; i++) {
              t = titles[i];
              if (t.title === args.title) {
                results.push(browser.switchTo().window(t.handle));
              } else {
                results.push(void 0);
              }
            }
            return results;
          }
        });
      } else if (args.frame) {
        return browser.switchTo().frame(testx.element(args.frame).getWebElement());
      }
    },
    'respond to dialog': async function(args) {
      var dialog;
      args = convertSimpleArgs(args, 'response');
      dialog = (await browser.switchTo().alert());
      switch (args.response.toLowerCase()) { // Key should be 'response'
        case "ok":
          return dialog.accept();
        case "cancel":
          return dialog.dismiss();
      }
    }
  };

}).call(this);
