// Generated by CoffeeScript 2.5.0
(function() {
  var acquire, fs, get, parsers, path;

  fs = require('fs');

  path = require('path');

  ({acquire} = require('../utils'));

  parsers = {};

  module.exports = {
    add: function(prsr, exts) {
      var ext, extensions, i, len, parser, ref;
      parser = acquire(prsr);
      extensions = typeof exts === 'string' ? [exts] : exts || [];
      ref = extensions.concat(parser.extensions);
      for (i = 0, len = ref.length; i < len; i++) {
        ext = ref[i];
        parsers[ext] = parser;
      }
      return this;
    },
    get: get = function(ext) {
      if (ext) {
        return parsers[ext];
      } else {
        return parsers;
      }
    },
    parseFile: function(file) {
      var extension, parser, script, stat;
      stat = fs.statSync(file);
      if (stat.isFile()) {
        extension = path.extname(file);
        if (extension[0] === '.') {
          extension = extension.slice(1);
        }
        if (parser = get(extension)) {
          return script = parser.parseFile ? parser.parseFile(file) : parser.parse(fs.readFileSync(file, 'utf8'));
        } else {
          return console.error(`Error while trying to parse ${file}.
Unknown file extension '${extension}'.
Did you install a parser for it?`);
        }
      } else {
        return console.error(`'${file}' is not a file.`);
      }
    }
  };

}).call(this);
