// Generated by CoffeeScript 2.5.0
(function() {
  var Duration, _, pr;

  _ = require('lodash');

  Duration = require('duration-js');

  module.exports = {
    timeout: function(tmt, defaultTmt, defaultUnit = 'ms') {
      var duration, m, match, r, timeout, unit;
      timeout = (function() {
        if (tmt) {
          r = /(\d+)(\D+)?/;
          if (match = tmt.match(r)) {
            [m, duration, unit] = match;
            unit = unit ? unit.trim() : defaultUnit;
            return `${duration}${unit}`;
          } else {
            throw new Error(`Wrong timeout format '${tmt}'`);
          }
        } else {
          return `${defaultTmt}${defaultUnit}`;
        }
      })();
      return new Duration(timeout).milliseconds();
    },
    defer: function(fn) {
      return setTimeout(fn, 0);
    },
    printable: pr = function(obj, delimiter = ', ') {
      var k, v;
      return ((function() {
        var results;
        results = [];
        for (k in obj) {
          v = obj[k];
          results.push(`${k.toLowerCase()}: '${v}'`);
        }
        return results;
      })()).join(delimiter);
    },
    acquire: function(pkg) {
      if (typeof pkg === 'string') {
        return require(pkg);
      } else {
        return pkg;
      }
    },
    defunc: function(obj) {
      if (typeof obj === 'function') {
        return obj();
      } else {
        return obj;
      }
    },
    assertFailedMsg: function(ctx, step) {
      var location, msg;
      location = pr(_.pick(ctx._meta, 'file', 'sheet', 'Row'));
      msg = `Failed expectation at ${location}`;
      if (step) {
        msg = `${msg}, keyword: '${step.name}'`;
      }
      return msg = `${msg}.`;
    }
  };

}).call(this);
